#!/usr/bin/env python
# coding: utf-8

# #### Импортируем пакеты

# In[1]:


import numpy as np
import pandas as pd
from matplotlib import pyplot as plt
import seaborn as sns
get_ipython().run_line_magic('matplotlib', 'inline')


# #### Считываем данные из файлов

# In[2]:


PD = pd.read_csv('player_data.csv')
PL = pd.read_csv('Players.csv')
SS = pd.read_csv('Seasons_Stats.csv')


# #### Смотрим на таблицы

# In[3]:


PL.head(3)


# In[4]:


PD.head(3)


# In[5]:


SS.head(3)


# In[6]:


# Формат таблиц
print('Size of Players table:', PL.shape)
print("Size of Players' Data table:", PD.shape)
print('Size of Statistics table:', SS.shape)


# In[7]:


# Убедимся, что имена игроков уникальны (чтобы далее можно было мерджить по этому полю)
len(PL['Player'].unique())


# Видно, что количество уникальных игроков совпадает с количеством строк таблицы "Players", значит все имена уникальны
# (можно мерджить)

# То, что в таблице "Players' Data" содержится больше строк, чем игроков, объясняется, очевидно, тем, что один и тот же игрок мог выступать в различных позициях (поле "position")

# In[8]:


# Посмотрим на списки полей по таблицам
print("Players:", PL.columns)
print("Players' Data:", PD.columns)
print("Statistics:", SS.columns)


# Замечаем, что таблица "Players' Data" не содержит принципиально отличных полей от тех, что содержатся совокупно в двух других (месяц и число рождения будем считать несущественными, поскольку не планируем строить астрологические модели, а year_start и year_end не несут новой информации в сравнении с Year). Поэтому попросту проигнорируем ее при смердживании двух других. При этом опустим "паразитные" колонки "Unnamed: 0".

# #### Создаем объединенную таблицу

# In[9]:


TAB = PL[PL.columns[1:]].merge(SS[SS.columns[1:]], left_on = 'Player', right_on = 'Player')


# In[10]:


# Посмотрим на таблицу
TAB.head()


# In[11]:


# Проверим размерность
TAB.shape


# Понятно, что в данной таблице игроки построчно повторяются. Оценим, каковы кратности таких повторений

# In[12]:


player_counts = TAB['Player'].value_counts()


# In[13]:


player_counts.head()


# In[14]:


plt.plot(np.array(player_counts))


# Видно, что большинство игроков (около75%) повторяются. Кратносто повтроения сильно варьируется. Есть небольшое количество игроков, повторяющихся более 20 раз. Основная часть повторяется порядка десятка раз. В связи с этим трудно определить сценарий агрегирования (какие агрегирующие функции брать, а также к каким метрикам применять) безотносительно к конкретной задаче моделирования (скажем, классификации, пока неопределеня даже целевая функция). 
# <b>Поэтому на данном этапе оставим таблицу как есть, а преобразования параметров будем применять ко всем строкам с одинаковыми игроками (ипостасям игроков)</b>

# In[15]:


TAB.info()


# Видно, что есть всего пять (кроме колонки "Player") категориальных признаков, остальные - числовые, при этом два из них (blanl и blank2) пустые и могут быть опущены. Кроме того, признаки "born" и "Age" преобразовывать не будем. План преобразования таков: 1) заполняем пропуски категориальных признаков значениями "NAN"; 2) пропуски числовых признаков заполняем медианами распределений; 3) затем к категориальным признакам применяем бинаризацию (поскольку она более экономна в сравнении с One hot encoding, т.к. множит признаки логарифмически по множеству уникальных категорий, в то время как последний - линейно); 4) к получившимся числовым (кроме года) применим нормализацию.

# In[16]:


cat = ["collage", "birth_city", "birth_state", "Pos", "Tm"]


# In[17]:


num = np.array(TAB.columns.difference(cat + ["Player", "Year", "blanl", "blank2", "born", "Age"]))


# #### 1. Заполняем пропуски категориальных признаков

# In[18]:


for col in cat:
    TAB[col].fillna("NAN", inplace = True)


# #### 2. Заполняем пропуски числовых признаков

# In[19]:


for col in num:
    TAB[col].fillna(TAB[col].median(), inplace = True)


# #### 3. Бинаризуем категориальне признаки

# In[20]:


# pip install category_encoders


# In[21]:


import category_encoders as ce


# In[22]:


TAB_cat = TAB[cat].copy()


# In[23]:


encoder = ce.BinaryEncoder(cols=cat)
TAB_cat_bin = encoder.fit_transform(TAB_cat)


# In[24]:


TAB_cat_bin.head()


# Оставим таблицу TAB_cat_bin как есть (не будем объединять ее с основной таблицей TAB), поскольку бинаризация не всегда уместна, в ряде случаев категориальные признаки вполне пригодны как есть. А для формирования матрицы признаков, нужна конкретизация модели и фича-селекшн, так что объединение таблиц можно отнести к этим этапам.

# #### 4. Нормализуем числовые признаки

# In[25]:


from sklearn import preprocessing as preproc


# In[26]:


for col in num:
    TAB[col] = preproc.normalize([TAB[col]])[0]


# In[27]:


TAB.head()


# In[ ]:




